;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; SMW Spike Top (sprite 2E), by imamelia
;;
;; This is a disassembly of sprite 2E in SMW, the Spike Top.
;;
;; Uses first extra bit: NO
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; defines and tables
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!ExtraBit = $04	; may be changed to 01 if using GEMS

InitXSpeed:
db $08,$00

InitYSpeed:
db $00,$08

XSpeed:
db $01,$FF,$FF,$01,$FF,$01,$01,$FF

YSpeed:
db $01,$01,$FF,$FF,$01,$01,$FF,$FF

XSpeed2:
db $08,$00,$F8,$00,$F8,$00,$08,$00

YSpeed2:
db $00,$08,$00,$F8,$00,$08,$00,$F8

ObjCheckVals:
db $01,$04,$02,$08,$02,$04,$01,$08

FrameData:
db $00,$02,$00,$02,$00,$02,$00,$02
db $05,$04,$05,$04,$05,$04,$05,$04

XYFlip:
db $00,$C0,$C0,$00,$40,$80,$80,$40
db $80,$C0,$40,$00,$C0,$80,$00,$40

Tilemap:
db $EC,$8C,$A8,$AA,$8E,$AC,$AE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; init routine wrapper
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc
PHB
PHK
PLB
JSR InitSpikeTop
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; init routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InitSpikeTop:

JSR SubHorzPos
TYA
EOR #$01
ASL #4
JSR InitSub
STZ $164A,x
LDA $151C,x
EOR #$10
STA $151C,x
LSR #2
STA $C2,x
RTS

InitSub:

LDY #$00
AND #$10
STA $151C,x
BNE StartOutLeft
INY
StartOutLeft:
LDA InitXSpeed,y	;
STA $B6,x		; set the sprite's initial X speed
LDA InitYSpeed,y	;
STA $AA,x	; set the sprite's initial Y speed
INC $164A,x	;
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine wrapper
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "MAIN ",pc
PHB
PHK
PLB
JSR Main
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Main:

JSL $018032	; interact with sprites
JSL $01ACF9	; get a random number
ORA $9D		;
BNE NoSet1	; if sprites are locked or the number was not 0...
LDA #$0C		; don't set this timer
STA $1558,x	;
NoSet1:		;

LDY $C2,x	; check the sprite state
LDA $1564,x	; sprite contact disable timer
BEQ NoAdd8	;
TYA		;
CLC		;
ADC #$08	; if the sprite disable timer is set, increase Y by 8
TAY		;
LDA #$00		; and send 0 to the next code
BRA SetFrame1	;

NoAdd8:		;

LDA $14		;
LSR #3		; make the sprite animate between 2 frames
AND #$01	;
SetFrame1:	;
CLC		;
ADC FrameData,y	; set the frame to show
STA $1602,x	;
LDA $15F6,x	;
AND #$3F	; clear the top two bits of the sprite palette
ORA XYFlip,y	; set the flip bits
STA $15F6,x	;

JSR SpikeTopGFX	;
     
LDA $14C8,x	;
CMP #$08		; if the sprite is still alive...
BEQ StillAlive	; skip this termination code
STZ $1528,x	;
LDA #$FF		;
STA $1558,x	; reset this timer

Return0:		;
RTS

StillAlive:		;

LDA $9D		; if sprites are locked...
BNE Return0	; return

JSR SubOffscreenX3	;

JSL $01A7DC	; interact with the player

; removed sprite number checks (2E, 3C, A5, A6)

LDA $D8,x		; sprite Y position
SEC			;
SBC $1C			; minus screen boundary
CMP #$E0			;
BCC NoOffscreenErase	; if the sprite is too far offscreen...
STZ $14C8,x		; erase it
NoOffscreenErase:		;

LDA $1540,x	;
BNE Skip1		; branch if the timer is set

LDY $C2,x	;
LDA YSpeed,y	; set the sprite's Y speed
STA $AA,x	;
LDA XSpeed,y	; set the sprite's X speed
STA $B6,x		;

JSL $019138	; interact with objects

LDA $1588,x	; check the sprite's object status
AND #$0F	; if the sprite is touching an object...
BNE Skip1		; branch

LDA #$08		;
STA $1564,x	; disable contact with other sprites
LDA #$1A		; timer = 1A
STA $1540,x	;

Skip1:		;

LDA #$10		; check value = 10
CMP $1540,x	; if the timer has reached the check value...
BNE NoChangeState	;
INC $C2,x	; change the sprite state
LDA $C2,x	;
CMP #$04		; if the sprite state has reached 04...
BNE NoResetState	;
STZ $C2,x	; reset it to 00
NoResetState:	;
CMP #$08		; if it is 08...
BNE NoChangeState	;
LDA #$04		; set it to 04
STA $C2,x	;

NoChangeState:	;

LDY $C2,x		;
LDA $1588,x		; check the object contact status
AND ObjCheckVals,y	; depending on the sprite state
BEQ Skip2			; if the sprite isn't touching the specified surface, skip the next part
LDA #$08			;
STA $1564,x		; disable contact with other sprites for a few frames
DEC $C2,x		; decrement the sprite state
LDA $C2,x		;
BPL CompareState1		; if the result was positive, branch
LDA #$03			;
BRA StoreState1		; set the sprite state to 03

CompareState1:		;

CMP #$03			;
BNE Skip2		;
LDA #$07			;
StoreState1:		;
STA $C2,x		;

Skip2:			;

LDY $C2,x		;
LDA YSpeed2,y		; set the sprite's Y speed
STA $AA,x		;
LDA XSpeed2,y		;
STA $B6,x			;

JSL $018022		; update sprite X position without gravity
JSL $01801A		; update sprite Y position without gravity

RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; graphics routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpikeTopGFX:

JSR GetDrawInfo

LDA $157C,x	;
STA $02		;

LDA $1602,x	;
TAX		;
LDA Tilemap,x	; set the sprite tilemap
STA $0302,y	;

LDX $15E9	;
LDA $00		;
STA $0300,y	; no X displacement
LDA $01		;
STA $0301,y	; no Y displacement

LDA $157C,x	;
LSR		; if the sprite is facing right...
LDA $15F6,x	;
BCS NoXFlip	; X-flip it
EOR #$40		;
NoXFlip:		;
ORA $64		;
STA $0303,y	;

TYA		;
LSR #2		;
TAY		;

LDA #$02		;
ORA $15A0,x	;
STA $0460,y	; set the tile size

PHK		;
PER $0006	;
PEA $8020	;
JML $81A3DF	; set up some stuff in OAM

RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; subroutines
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Table1:              db $0C,$1C
Table2:              db $01,$02
Table3:              db $40,$B0
Table6:              db $01,$FF
Table4:              db $30,$C0,$A0,$C0,$A0,$F0,$60,$90,$30,$C0,$A0,$80,$A0,$40,$60,$B0
Table5:              db $01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$00,$01,$FF

;SubOffscreenX0:
;LDA #$00
;BRA SubOffscreenMain
;SubOffscreenX1:
;LDA #$02
;BRA SubOffscreenMain
;SubOffscreenX2:
;LDA #$04
;BRA SubOffscreenMain
SubOffscreenX3:
LDA #$06
;BRA SubOffscreenMain
;SubOffscreenX4:
;LDA #$08
;BRA SubOffscreenMain
;SubOffscreenX5:
;LDA #$0A
;BRA SubOffscreenMain
;SubOffscreenX6:
;LDA #$0C
;BRA SubOffscreenMain
;SubOffscreenX7:
;LDA #$0E

SubOffscreenMain:

STA $03

JSR SubIsOffscreen
BEQ Return2

LDA $5B
LSR
BCS VerticalLevel
LDA $D8,x
CLC
ADC #$50
LDA $14D4,x
ADC #$00
CMP #$02
BPL EraseSprite
LDA $167A,x
AND #$04
BNE Return2
LDA $13
AND #$01
ORA $03
STA $01
TAY
LDA $1A
CLC
ADC Table4,y
ROL $00
CMP $E4,x
PHP
LDA $1B
LSR $00
ADC Table5,y
PLP
SBC $14E0,x
STA $00
LSR $01
BCC Label20
EOR #$80
STA $00
Label20:
LDA $00
BPL Return2

EraseSprite:
LDA $14C8,x
CMP #$08
BCC KillSprite
LDY $161A,x
CPY #$FF
BEQ KillSprite
LDA #$00
STA $1938,y
KillSprite:
STZ $14C8,x
Return2:
RTS

VerticalLevel:

LDA $167A,x
AND #$04
BNE Return2
LDA $13
LSR
BCS Return2
AND #$01
STA $01
TAY
LDA $1C
CLC
ADC Table3,y
ROL $00
CMP $D8,x
PHP
LDA $1D
LSR $00
ADC Table6,y
PLP
SBC $14D4,x
STA $00
LDY $02
BEQ Label22
EOR #$80
STA $00
Label22:
LDA $00
BPL Return2
BMI EraseSprite

SubIsOffscreen:
LDA $15A0,x
ORA $186C,x
RTS

GetDrawInfo:

STZ $186C,x
STZ $15A0,x
LDA $E4,x
CMP $1A
LDA $14E0,x
SBC $1B
BEQ OnscreenX
INC $15A0,x
OnscreenX:
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
SEC
SBC $1A
CLC
ADC.w #$0040
CMP #$0180
SEP #$20
ROL A
AND #$01
STA $15C4,x
BNE Invalid

LDY #$00
LDA $1662,x
AND #$20
BEQ OnscreenLoop
INY
OnscreenLoop:
LDA $D8,x
CLC
ADC Table1,y
PHP
CMP $1C
ROL $00
PLP
LDA $14D4,x
ADC #$00
LSR $00
SBC $1D
BEQ OnscreenY
LDA $186C,x
ORA Table2,y
STA $186C,x
OnscreenY:
DEY
BPL OnscreenLoop
LDY $15EA,x
LDA $E4,x
SEC
SBC $1A
STA $00
LDA $D8,x
SEC
SBC $1C
STA $01
RTS

Invalid:
PLA
PLA
RTS

SubHorzPos:

LDY #$00
LDA $94
SEC
SBC $E4,x
STA $0F
LDA $95
SBC $14E0,x
BPL $01
INY
RTS











